---
title: CanvasRenderingContext2D.getTransform()
slug: Web/API/CanvasRenderingContext2D/getTransform
tags:
  - API
  - Canvas
  - CanvasRenderingContext2D
  - Method
  - Reference
---
<div>{{APIRef}}</div>

<p>The <code><strong>CanvasRenderingContext2D</strong></code><strong><code>.getTransform()</code></strong> method of the Canvas 2D API retrieves the current transformation matrix being applied to the context.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">let <em>storedTransform<strong> = </strong>ctx</em>.getTransform();
</pre>

<h3 id="Parameters">Parameters</h3>

<p>None.</p>

<h3 id="Return_value">Return value</h3>

<p>A {{domxref("DOMMatrix")}} object.</p>

<p>The transformation matrix is described by: <math><semantics><mrow><mo>[</mo><mtable columnalign="center center center" rowspacing="0.5ex"><mtr><mtd><mi>a</mi></mtd><mtd><mi>c</mi></mtd><mtd><mi>e</mi></mtd></mtr><mtr><mtd><mi>b</mi></mtd><mtd><mi>d</mi></mtd><mtd><mi>f</mi></mtd></mtr><mtr><mtd><mn>0</mn></mtd><mtd><mn>0</mn></mtd><mtd><mn>1</mn></mtd></mtr></mtable><mo>]</mo></mrow><annotation encoding="TeX">\left[ \begin{array}{ccc} a &amp; c &amp; e \\ b &amp; d &amp; f \\ 0 &amp; 0 &amp; 1 \end{array} \right]</annotation></semantics></math></p>

<div class="notecard note">
<p><strong>Note</strong>: The returned object is not live, so updating it will not affect the current transformation matrix, and updating the current transformation matrix will not affect an already returned <code>DOMMatrix</code>.</p>
</div>

<h2 id="Examples">Examples</h2>

<p>In the following example, we have two {{htmlelement("canvas")}} elements. We apply a transform to the first one's context using {{domxref("CanvasRenderingContext2D.setTransform()")}} and draw a square on it, then retrieve the matrix from it using <code>getTransform()</code>.</p>

<p>We then apply the retrieved matrix directly to the second canvas context by passing the <code>DOMMatrix</code> object directly to <code>setTransform()</code>, and draw a circle on it.</p>

<h4 id="HTML">HTML</h4>

<pre class="brush: html">&lt;canvas width="240"&gt;&lt;/canvas&gt;
&lt;canvas width="240"&gt;&lt;/canvas&gt;
</pre>

<h4 id="CSS">CSS</h4>

<pre class="brush: css">canvas {
  border: 1px solid black;
}</pre>

<h4 id="JavaScript">JavaScript</h4>

<pre class="brush: js">const canvases = document.querySelectorAll('canvas');
const ctx1 = canvases[0].getContext('2d');
const ctx2 = canvases[1].getContext('2d');

ctx1.setTransform(1, .2, .8, 1, 0, 0);
ctx1.fillRect(25, 25, 50, 50);

let storedTransform = ctx1.getTransform();
console.log(storedTransform);

ctx2.setTransform(storedTransform);
ctx2.beginPath();
ctx2.arc(50, 50, 50, 0, 2 * Math.PI);
ctx2.fill();</pre>

<h4 id="Result">Result</h4>

<p>{{ EmbedLiveSample('Examples', "100%", 180) }}</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('HTML WHATWG', "scripting.html#dom-context-2d-gettransform", "CanvasRenderingContext2D.getTransform")}}</td>
   <td>{{Spec2('HTML WHATWG')}}</td>
   <td></td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.CanvasRenderingContext2D.getTransform")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>The interface defining this method: {{domxref("CanvasRenderingContext2D")}}</li>
 <li>{{domxref("CanvasRenderingContext2D.transform()")}}</li>
</ul>
